from __future__ import print_function
import sys
import TSP_Utilities

def bfa(a,n):

###################################################################
# Ausprobieren aller Moeglichkeiten; erste Stadt ist fest gesetzt #
###################################################################

   counter = 0
   weg = [0]
   optweg = []
   weglaenge=0
   rest = range(1,n)
   optlaenge=sys.maxsize
   optweg, optlaenge, counter = bf(weg,weglaenge,rest,optweg,optlaenge,a,n,counter)
   return optweg, optlaenge, counter
      
      
def bf(weg,weglaenge,rest,optweg,optlaenge,a,n,counter):

# Ausprobieren aller Moeglichkeiten

# Weg:  aktuelle Tour
# rest: noch zu besuchende Orte
# a:    Distanzmatrix
# n:    Gesamtzahl der Staedte

   for i in rest:
      aktlaenge = weglaenge
      aktweg = weg[:]
      aktrest = rest[:]
      aktweg.append(i)
      aktrest.remove(i)
      l=len(aktweg)
      if l<n:
         if l >1:
            # berechne Laenge des aktuellen Weges
            aktlaenge = aktlaenge+a[aktweg[l-2]][aktweg[l-1]]
         # verlaengere aktuelle Tour um eine weitere Stadt
         optweg, optlaenge, counter=bf(aktweg,aktlaenge,aktrest,optweg,optlaenge,a,n,counter) 
      else:
         counter = counter + 1
         # Berechne Laenge der aktuellen Tour
         aktlaenge = aktlaenge+a[aktweg[0]][aktweg[n-1]]+a[aktweg[n-2]][aktweg[n-1]]
         # checke, ob aktuelle Tour kuerzer ist; wenn ja, dann speichere
         # aktuelle Tour als (bisher) optimale Tour
         print ("Laenge: ", aktlaenge, " Tour: ",aktweg)
         if aktlaenge < optlaenge:
            optlaenge = aktlaenge
            optweg = aktweg[:]
            print ("neue kuerzeste Rundreise gefunden:", optweg,optlaenge)
   return optweg, optlaenge, counter

####################
# nearest_neighbor #
####################
def nearest_neighbor(distance, size, start):
    '''
        Nearest neighbor algorithms with a given node as starting point.

        Input:  distance: Quadratic distance distance.
                start: First city to start nearest neighbour search.
        Output: Best tour, best tour length.
    '''

    # Tour begins with start node.
    tour = [start]
    for i in range(1, size):
        tour.append(0)

    # Construct list of cities which have not been visited in the actual tour.
    open_city = []
    for i in range(0, size):
        # Add all cities, except the start.
        if i != start:
            open_city.append(i)

    # Construct tour by appending the nearest city.
    for position in range(1, size):
        # Current city.
        act_city = tour[position - 1]

        # Search city with minimal distance to current city.
        minimal_distance = sys.maxsize
        for next_city in open_city:
            act_distance = distance[act_city][next_city]
            if act_distance < minimal_distance:
                # A nearer neighbor has been found.
                tour[position] = next_city
                minimal_distance = act_distance
        
        # Remove new city from open city list.
        open_city.remove(tour[position])
    
    # Compute tour length
    length = TSP_Utilities.tour_length(distance, tour)

    # Return the tour and its length.
    return tour, length

#################
# HAUPTPROGRAMM #
#################

print ("Dies ist ein Programm, welches zwei verschiedene Ansaetze zur Loesung des")
print ("Rheinlandproblems verwendet: das Ausprobieren aller Moeglichkeiten und")
print ("den Nearest Neighbor Algorithmus.")
print ("Beim Ausprobieren aller Moeglichkeiten wird die Startstadt hier nicht variiert.")
print()
# Entfernungsmatrix einlesen
n=6
file_name = "rundreise_input_6.txt"
distance = TSP_Utilities.read_distance(file_name,n)

# Print distance matrix   
print("Die Entfernungstabelle beim Rheinlandproblem lautet:")
TSP_Utilities.print_distance(distance)

# Ausprobieren aller Moeglichkeiten
print()
print ("Ausprobieren aller Moeglichkeiten:")
print ()
optweg_bfa, optsumme_bfa, counter = bfa(distance,n)
print()
print ("Kuerzeste Rundreise beim Ausprobieren aller Moeglichkeiten:")
print ("Laenge: ", optsumme_bfa)
print ("Optimale Tour: ", optweg_bfa)
print ("Andere kuerzeste Rundreisen erhaelt man durch zyklische Vertauschung der")
print ("Staedte oder wenn man die Rundreise in Gegenrichtung durchlaeuft.")
print ("Insgesamt wurden ", counter, " Touren ausprobiert.")
print()
print()

# Nearest Neighbor Algorithmus
print ("Kuerzeste Rundreisen beim Nearest-Neighbor-Algorithmus, wenn man im ")
print ("Algorithmus die Startstaedte variiert:")
nn_glob_opt=[]
nn_glob_min=sys.maxsize
for start in range(n):
   optnn, optsumnn = nearest_neighbor(distance,n,start)
   print ("Startstadt: ",start, ", Laenge: ", optsumnn)
   print (" Kuerzeste vom Nearest Neigbor Algorithmus gefundene Rundreise:",optnn)
   print ()
   if optsumnn<nn_glob_min:
      nn_glob_min = optsumnn
      nn_glob_opt = optnn[:]

print ("Kuerzeste vom Nearest-Neigbor-Algorithmus gefundene Rundreise bei Variation der Startstadt:", ) 
print ("Laenge: ",nn_glob_min)
print ("Route: ",nn_glob_opt)

sys.stdin.readline()
